Issue #13955 has been updated by nagachika (Tomoyuki Chikanaga).

Backport changed from 2.3: REQUIRED, 2.4: REQUIRED to 2.3: REQUIRED, 2.4: DONE

ruby_2_4 r61456 merged revision(s) 60071.

----------------------------------------
Bug #13955: NKF.nkf のオプション文字列が SHARABLE_MIDDLE_SUBSTRING=1 を考慮していない
https://bugs.ruby-lang.org/issues/13955#change-68631

* Author: tommy (Masahiro Tomita)
* Status: Closed
* Priority: Normal
* Assignee: 
* Target version: 
* ruby -v: 
* Backport: 2.3: REQUIRED, 2.4: DONE
----------------------------------------
SHARABLE_MIDDLE_SUBSTRING=1 でコンパイルしたRubyで、NKF.nkf のオプション文字列が正しく扱われません。

```
% ruby -rnkf -e 'opt="--ic=UTF-8 --oc=EUC-JISX0213 -w"[0,28]; p opt; p NKF.nkf(opt, "あ").encoding'
"--ic=UTF-8 --oc=EUC-JISX0213"
#<Encoding:UTF-8>
```

次のパッチで直ると思います。

```diff
diff --git a/ext/nkf/nkf.c b/ext/nkf/nkf.c
index 9613a925ce..df32e9cf0b 100644
--- a/ext/nkf/nkf.c
+++ b/ext/nkf/nkf.c
@@ -137,7 +137,7 @@ rb_nkf_convert(VALUE obj, VALUE opt, VALUE src)
 {
     VALUE tmp;
     reinit();
-    StringValue(opt);
+    StringValueCStr(opt);
     nkf_split_options(RSTRING_PTR(opt));
     if (!output_encoding) rb_raise(rb_eArgError, "no output encoding given");
 
```

適用後

```
% ruby -rnkf -e 'opt="--ic=UTF-8 --oc=EUC-JISX0213 -w"[0,28]; p opt; p NKF.nkf(opt, "あ").encoding'
"--ic=UTF-8 --oc=EUC-JISX0213"
#<Encoding:EUC-JIS-2004>
```



-- 
https://bugs.ruby-lang.org/